﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using Sample142103;
using Syncfusion.EJ.Export;
using Syncfusion.JavaScript.Models;
using Syncfusion.XlsIO;
using System.Web.Script.Serialization;
using System.Collections;
using System.Reflection;
using MVCSampleBrowser.Models;
using Syncfusion.JavaScript;
using System.Drawing;
namespace Sample142103.Controllers
{
    public class GridController : Controller
    {
        //
        // GET: /Grid/
        List<Employees> employee = new List<Employees>();

        public ActionResult GridFeatures()
        {
            var MasterData = new NorthwindDataContext().EmployeeViews.Take(5).ToList();
            ViewBag.dataSource1 = MasterData;
            var DetailData = new NorthwindDataContext().OrdersViews.Take(5).ToList();
            ViewBag.dataSource2 = DetailData;
            var DetailedData = BindDataSource();
            ViewBag.dataSource3 = DetailedData;
            return View();
        }

        public void MultipleExportToExcel(string[] GridModel)
        {
            ExcelExport exp = new ExcelExport();
            var EmployeeData = new NorthwindDataContext().EmployeeViews.Take(5).ToList();
            var OrderData = new NorthwindDataContext().OrdersViews.Take(5).ToList();
            var DetailedData = BindDataSource();
            bool initial = true;
            IWorkbook book = null;
            IWorkbook book2 = null;
            for (int i =0 ; i < GridModel.Count(); i++)
            {
                string gridProperty = GridModel[i];
                GridProperties gridProp = ConvertObject(gridProperty);
                if (initial)
                {
                    gridProp.Locale = "";
                    book = exp.Export(gridProp, EmployeeData, "Export.xlsx", ExcelVersion.Excel2010, true, true, "flat-saffron", true);
                    initial = false;
                }
                else
                {
                    if (i != 2)
                    {
                        book2 = exp.Export(gridProp, OrderData, "Export2.xlsx", ExcelVersion.Excel2010, true, true, "flat-saffron", true);

                        IWorksheet booksheet = book.Worksheets[0];

                        IWorksheet book2worksheet = book2.Worksheets[0];

                        IRange sourceRange = booksheet.UsedRange;

                        IRange destinationRange = book2worksheet.UsedRange;

                      //  //Copying (90 rows) from Source to Destination worksheet.

                        destinationRange.CopyTo(booksheet.Range[sourceRange.LastRow + 2, 1]);
                                          
                    }
                    else
                        exp.Export(gridProp, DetailedData, "Export.xlsx", ExcelVersion.Excel2010, true, true, "flat-saffron", false, book, MultipleExportType.AppendToSheet, "Third Grid");
                }
            }
        }
        private GridProperties ConvertObject(string gridProperty)
        {
            JavaScriptSerializer serializer = new JavaScriptSerializer();
            IEnumerable div = (IEnumerable)serializer.Deserialize(gridProperty, typeof(IEnumerable));
            GridProperties gridProp = new GridProperties();
            GridExtensions ext = new GridExtensions();
            AutoFormat auto = new AutoFormat();
            ext.SetTheme(auto, "flat-saffron");
            auto.FontFamily = "Calibri";
            auto.GContentFontColor = Color.Blue;
            gridProp.AutoFormat = auto;
            foreach (KeyValuePair<string, object> ds in div)
            {
                var property = gridProp.GetType().GetProperty(ds.Key, BindingFlags.Instance | BindingFlags.Public | BindingFlags.IgnoreCase);
                if (property != null)
                {
                    Type type = property.PropertyType;
                    string serialize = serializer.Serialize(ds.Value);
                    object value = serializer.Deserialize(serialize, type);
                    property.SetValue(gridProp, value, null);
                }
            }
            return gridProp;
        }

        public List<Employees> BindDataSource()
        {
            employee.Add(new Employees(1, "Nancy"));
            employee.Add(new Employees(2, "Andrew"));
            employee.Add(new Employees(3, "Janet"));
            employee.Add(new Employees(4, "Janet"));
            employee.Add(new Employees(5, "Janet"));

            return employee;
        }

        [Serializable]
        public class Employees
        {
            public Employees()
            {

            }
            public Employees(int EmployeeId, string FirstName)
            {
                this.EmployeeID = EmployeeId;
                this.FirstName = FirstName;
            }
            public int EmployeeID { get; set; }
            public string FirstName { get; set; }
        }
    }
}
